
from pymtn_lib20 import *

def DevInit():
    print("--控制器初始化开始")
    ''' 搜索控制器'''
    (devNum, devinfolist, ret) = pymtn.NMC_DevSearch(pymtn.TSearchMode.Internet)
    if ret != 0:
        print("控制器搜索出错,返回值为:", ret)
        exit()
    if ret == 0:
        print("the count of devices: (%s)" % (devNum))
        for i in range(0, devNum):
            print(devinfolist[i].address)
            print(devinfolist[i].idStr)
            print(devinfolist[i].description)
            print(devinfolist[i].ID)
    if devNum <= 0:
        print("没有找到控制器")
        exit()

    ''' 打开第一个控制器'''
    (devHandle, ret) = pymtn.NMC_DevOpenByID(devinfolist[0].idStr)
    if ret != pymtn.RTN_CMD_SUCCESS:
        print("控制器打开出错", ret)
        exit()

    # ''' 打开第一个控制器--只有一张卡的时候，直接打开，不用搜索'''
    # (devHandle, ret) = pymtn.NMC_DevOpen(0)
    # if ret != pymtn.RTN_CMD_SUCCESS:
    #     print("控制器打开出错", ret)
    #     exit()

    (Info, ret) = pymtn.NMC_GetCardInfo(devHandle)
    num = Info.axisNum
    axisHandle = [c_ushort(0)] * num
    for i in range(0, num):
        (axisHandle[i], ret) = pymtn.NMC_MtOpen(devHandle, i)
        if ret != pymtn.RTN_CMD_SUCCESS:
            print("控制器打开出错", ret)
            exit()

    print("控制器初始化结束")
    return (devHandle, axisHandle)

"""--------------------捕获功能--------------------"""
def Ext_HardwareCapture(devHandle, axisHandle):
    print("捕获功能 测试开始")
    # 设置编码器捕获敏感参数
    mode = pymtn.CAPT_MODE_IO
    ioSrc = pymtn.CAPT_IO_SRC_HOME
    level = 0

    ret = pymtn.NMC_MtSetCaptSns(axisHandle, mode, ioSrc, level)
    if ret != 0:
        print(f"设置捕获敏感参数失败，错误码: {ret}")
    else:
        print("设置捕获敏感参数成功")


    # 启动捕获
    ret = pymtn.NMC_MtSetCapt(axisHandle)
    if ret != 0:
        print(f"启动捕获失败，错误码: {ret}")
    else:
        print("启动捕获成功")
    while 1:
        stsword, ret = pymtn.NMC_MtGetSts(axisHandle)
        if (stsword.value & pymtn.BIT_AXIS_CAPTSET) == pymtn.BIT_AXIS_CAPTSET:# 已经捕获到
            # 读取捕获位置（当捕获触发后）
            pos_tmp, ret = pymtn.NMC_MtGetCaptPos(axisHandle)
            if ret != 0:
                print(f"读取捕获位置失败，错误码: {ret}")
            else:
                print(f"捕获位置: {pos_tmp.value} 脉冲")
                break

    print("捕获功能 测试结束")
if __name__ == "__main__":

    devHandle, axisHandle = DevInit()
    Ext_HardwareCapture(devHandle, axisHandle[0])